/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* ArquivoRemoto.java */

import siscoma.orb.*;
import siscoma.orb.ServentePackage.*;
import java.util.*;

public class ArquivoRemoto {

  String Nome; 
  String NomeServ;
  int Tamanho; 
  int Hash; 
  Servente Servidor;
  String Id;
  
  ArquivoRemoto(String nome, int tamanho, int hash, 
		Servente servidor, String id) {
    Nome = nome;
    Tamanho = tamanho;
    Hash = hash;
    Servidor = servidor;
    Id = id;
    NomeServ = servidor.nome_servente();
  } 

  public String nome() {
    return Nome;
  }
  public String nomeDoServidor() {
    return NomeServ;
  }

  public int tamanho() {
    return Tamanho;
  }

  public int hash() {
    return Hash;
  }

  public Servente servidor() {
    return Servidor;
  }

  public String id() {
    return Id;
  }

  public boolean arquivoIgual(ArquivoRemoto ar) {
    //return (Tamanho == ar.tamanho() && Hash == ar.hash());
    return (Tamanho == ar.tamanho());
  }

  public String toString() {
    return new String("ArquivoRemoto: " + Nome + " " + Tamanho + " " + Hash + " " + 
		      Servidor.nome_servente() + " " + Id);
  }
}



