/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* CaixaDeMensagens.java */

import java.util.ArrayList;

public class CaixaDeMensagens {

  private ArrayList mensagens;

  private static final int TDV = 60;


  public CaixaDeMensagens ( ) {

    this.mensagens = new ArrayList( );

  }

  
  public void guarde (String id) {

    mensagens.add(new Mensagem(id, TDV));
    
  }
  
  public void remova (String id) {

    for (int i = 0; i < mensagens.size( ); i++) {
      Mensagem m = (Mensagem) mensagens.get(i);
      if (m.id( ).equals(id)) {
	mensagens.remove(i);
	break;
      }
    }

  }

  public boolean recebi (String id) {

    for (int i = 0; i < mensagens.size( ); i++) {
      Mensagem m = (Mensagem) mensagens.get(i);
      if (m.id( ).equals(id)) return true;
    }
    return false;
    
  }

  public void decTdv ( ) {

    for (int i = 0; i < mensagens.size( ); i++) {
      Mensagem m = (Mensagem) mensagens.get(i);
      m.decTdv( );      
    }
    for (int i = 0; i < mensagens.size( ); i++) {
      Mensagem m = (Mensagem) mensagens.get(i);
      if (m.tdv( ) <= 0) {
	System.out.println("CaixaDeMensagens: removendo " + m.id( ));
	mensagens.remove(i);
      }
    }

  }
  
  public void removaAntigas ( ) {

    for (int i = 0; i < mensagens.size( ); i++) {
      Mensagem m = (Mensagem) mensagens.get(i);
      if (m.tdv( ) <= 0) {
	mensagens.remove(i);
      }
    }

  }
  
}
