/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* ExcArquivoDiferente.java */

import siscoma.orb.*;

/**
 * Lanada quando  tentada uma troca de servidor
 * numa transferncia.
 */
public class ExcArquivoDiferente extends Exception {
 
  private ArquivoRemoto ARAnt;
  private ArquivoRemoto ARNovo;
 
  public ExcArquivoDiferente() { super(); }
  public ExcArquivoDiferente(ArquivoRemoto arAnt, ArquivoRemoto arNovo) { 
    super(); 
    ARAnt = arAnt;
    ARNovo = arNovo;
  }
 
  public ArquivoRemoto arAntigo(){ return ARAnt; }
  public ArquivoRemoto arNovo(){ return ARNovo; }
}
