/* MAC 440/5759 - Sistemas de Objetos Distribudos  */
/* IME-USP - 1o.sem/2002 - Prof. Fabio Kon          */
/*                                                  */
/* Projeto Final: Siscoma                           */
/*                                                  */
/* Emerson Luiz Navarro  - emr@linux.ime.usp.br     */
/* Leo Kazuhiro Ueda     -  lku@ime.usp.br          */
/* Pratip Roy Chowdhury  - roy@linux.ime.usp.br     */
/* Ricardo Hideo Sahara  - hideo@linux.ime.usp.br   */
/*                                                  */


/* JUpload.java */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.table.*;


public class JUpload extends JPanel {  

  private JSiscoma pai;

  private JList ltUploads;

  private DefaultListModel lmUploads;

  private static final int MAX = 50;
  
  
  public JUpload (JSiscoma pai) {

    setPreferredSize(new Dimension(600, 600));
    setVisible(true);        
    this.pai = pai;
    
    JPanel p1 = new JPanel( );        
    p1.setBorder(BorderFactory.createTitledBorder("Uploads"));    
    p1.setPreferredSize(new Dimension(600, 500));
    this.lmUploads = new DefaultListModel();
    this.ltUploads = new JList(lmUploads);
    JScrollPane listScrollPane = new JScrollPane(ltUploads);
    listScrollPane.setPreferredSize(new Dimension(500, 400));   
    p1.add(listScrollPane);    
    add(p1);
   
  }

  public void novoUpload(String arq, int pos, int numBytes) {

    String s = "Arquivo = " + arq + " - " 
      + "Posio = "+ Integer.toString(pos) + " bytes - " 
      + "Tam. do bloco = " + Integer.toString(numBytes);    
    if (lmUploads.getSize( ) == MAX) {
      lmUploads.removeElementAt(MAX - 1);      
    }
    lmUploads.add(0, s);
    
  }
  

}
